/* GCC */

#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int powlog(int x, int n, int p){
    int ans = 1;
    if (n == 0) return 1;
    if (n&1){
        ans = powlog(x, (n-1)/2, p);
        return ((x%p)*((ans*ans)%p))%p;
    } else {
        ans = powlog(x, n/2, p);
        return (ans*ans)%p;
    }
}

int bpk(int p, int k){
    int ans = 1;
    int PinK = powlog(p, k, 1000000000);

    for (int i = 1; i <= PinK; i++) if (i%p != 0){
        ans = (ans*i)%PinK;
    }
    return ans;
}

int smpk (int m, int p, int k){
    int ans  = 1;
    int PinK = powlog(p, k, 1000000000);

    for (int i = 1; i<=m; i++) if (i%p != 0){
        ans = (ans*i)%PinK;
    }
    return ans;
}

int calc(int n, int p, int k){
    if (n == 0) return 1;

    int PinK = powlog(p, k, 1000000000);
    int b, s, last;
    b = powlog(bpk(p, k), n/PinK, PinK);
    s = smpk(n%PinK, p, k);
    last = calc(n/p, p, k);

    return (b*s*last)%PinK;

}

int main(){
    freopen("factrl.in", "r", stdin);
    freopen("factrl.out", "w", stdout);

    int n, k2 = 0, k5 = 0, inmax2, inmax5;

    scanf("%d", &n);

    int n1 = n;
    while (n1 > 0){
        k2 += n1/2;
        n1 = n1/2;
    }
    n1 = n;
    while (n1 > 0){
        k5 += n1/5;
        n1 = n1/5;
    }

    inmax2 = powlog(2, k2, 125);
    inmax5 = powlog(5, k5, 8);

    int A,B;
    A = calc(n, 2, 3);
    B = calc(n, 5, 3);

//    printf("%d, %d\n", A, B);

    int A0 = -1, B0 = -1;

    for (int i = 1; i<8; i++) if (i%2 != 0){
        if ((i*inmax5)%8 == A%8) {
            A0 = i;
            break;
        }
    }

    for (int i = 1; i<125; i++) if (i%5 != 0){
        if ((i*inmax2)%125 == B%125){
            B0 = i;
            break;
        }
    }

//    printf("%d %d\n", A0, B0);

    int N0 = -1;

    for (int i = 0; i<1000; i++){
        if ((i%8 == A0) && (i%125 == B0)){
            N0 = i;
            break;
        }
    }

//    printf("N0 preveiw = %d\n", N0);

    int twoin = powlog(2, k2-k5, 1000);

    N0 = (N0*twoin)%1000;

    printf("%.3d\n", N0);

    return 0;
}
