/* GCC */
#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <vector>
#include <stdio.h>

/* pls 100 */

using namespace std;

vector <long long> tree;
vector <pair<long long,long long> > player;
vector <int> pos;
vector <int> parant;
vector <int> zapros;
vector <int> a;

bool comp (int i, int j){
    return (player[i].second == player[j].second && player[i].first < player[j].first) || player[i].second < player[j].second;
}

void update(int v, int l, int r, int p, long long val){
    if (l + 1 == r){
        tree[v] = val;
        return;
    }
    int mid = (l + r) >> 1;
    if (mid <= p) update(2*v+1,mid,r,p,val);
    else update(2*v,l,mid,p,val);
    tree[v] = max(tree[2*v],tree[2*v+1]);
}

int leftelement(int v, int l, int r, long long val){
    if (tree[v] <= val) return -1;
    if (l + 1 == r) return l;
    int mid = (l + r) >> 1;
    if (tree[2*v] > val) return leftelement(2*v,l,mid,val);
    return leftelement(2*v+1,mid,r,val);
}

int element (int v, int l, int r, int p, long long val){
    if (l + 1 == r) return -1;
    int mid = (l + r) >> 1;
    if (mid <= p) return element(2*v+1,mid,r,p,val);
    int ans = element(2*v,l,mid,p,val);
    if (ans == -1) ans = leftelement(2*v+1,mid,r,val);
    return ans;
}

int main(){
    ifstream fin("cclub.in");
    ofstream fout("cclub.out");
    ios_base::sync_with_stdio(false);
    fin.tie(false);
    fout.tie(false);
    int q;
    fin >> q;
    zapros.resize(q);
    for (int i = 0; i < q; i++){
        string s;
        fin >> s;
        if (s == "P"){
            pair<long long,long long> t;
            fin >> t.first >> t.second;
            player.push_back(t);
            zapros[i] = player.size() - 1;
        } else fin >> zapros[i], zapros[i] *= -1;
    }
    int n = player.size();
    a.resize(n);
    pos.resize(n);
    parant.resize(n);
    tree.assign(4*n,0);
    for (int i = 0; i < n; i++) a[i] = i;
    sort(a.begin(),a.end(), comp);
    for (int i = 0; i < n; i++) pos[a[i]] = i;
    parant[n-1] = n-1;
    for (int i = n - 2; i > -1; i--)
        if (player[a[i]].second == player[a[i + 1]].second) parant[i] = parant[i + 1];
        else parant[i] = i;
    for (int i = 0; i < q; i++){
        if (zapros[i] >= 0)
            update(1,0,n,pos[zapros[i]],player[zapros[i]].first);
        else{
            zapros[i] = -zapros[i]-1;
            int v = parant[pos[zapros[i]]];
            int ans = -1;
            if (v != n-1) ans = element(1,0,n,v,player[zapros[i]].first);
            if (ans != -1) ans = a[ans];
            fout << ans + 1 << '\n';
        }
    }
    fin.close();
    fout.close();
    return 0;
}
