/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
typedef long long int64;
int n;
int64 x, y, num, setN;
struct user{
    int64 x, y, n;
    user(int64 a, int64 b, int64 c){
        x=a, y=b, n=c;
    }
};
struct query{
    char type;
    int64 x, y, n;
    query(char q, int64 a, int64 b, int64 c){
        type=q, x=a, y=b, n=c;
    }
    query(){};
};
bool mycmp(user a, user b){
    return a.y<b.y || (a.y==b.y && a.x<b.x);
}
vector<query> lineQuery;
vector<int64> lvl, tree;
vector<int> ans;
vector<user> line;

void readData(){
    freopen("cclub.in", "r", stdin);

    int times;
    int64 j, k;
    char c;
    int curr=0;
    scanf("%d\n", &times);
    lineQuery=vector<query>(times);
    for(int i=0; i<times; i++){
        scanf("%c", &c);
        if(c=='P'){
            scanf("%I64d%I64d\n", &j, &k);
            lineQuery[i]=(query('P', j, k, curr));
            line.push_back(user(j, k, curr));
            curr++;
        } else {
            scanf("%I64d\n", &j);
            lineQuery[i]=(query('G', 0, 0, j-1));
        }
    }
    n=curr;

    fclose(stdin);
}

void buildTree(){
    sort(line.begin(), line.end(), mycmp);
    lvl=vector<int64>(n);
    for(int i=0; i<line.size(); i++){
        lvl[ line[i].n ]=i;
    }
    tree.assign(4*n, 0);
}

void setMax(int64 pos, int64 l, int64 r){
    if(l==r){
        tree[pos]=setN;
        return;
    }
    int64 m=l+(r-l)/2;
    if(num<=m){
        setMax(pos*2, l, m);
    } else {
        setMax(pos*2+1, m+1, r);
    }
    tree[pos]=max(tree[pos*2], tree[pos*2+1]);
}

int getAnswer(int64 pos, int64 l, int64 r){
    if(l==r) return line[l].n+1;
    int64 m=l+(r-l)/2, u=0;
    if(line[m].y>y && tree[pos*2]>x)
        u=getAnswer(pos*2, l, m);
    if(u==0 && line[r].y>y && tree[pos*2+1]>x)
        return getAnswer(pos*2+1, m+1, r);
    return u;
}

void launchQueries(){
    int curr;
    for(int i=0; i<lineQuery.size(); i++){
        curr=lvl[lineQuery[i].n];
        if(lineQuery[i].type=='P'){
            num=lvl[lineQuery[i].n];
            setN=lineQuery[i].x;
            setMax(1, 0, n-1);
        } else {
            x=line[curr].x;
            y=line[curr].y;
            ans.push_back( getAnswer(1, 0, n-1) );
        }
    }
}

void fileOut(){
    freopen("cclub.out", "w", stdout);

    for(int i=0; i<ans.size(); i++){
        printf("%d\n", ans[i]);
    }

    fclose(stdout);
}

int main(){
    readData();
    buildTree();
    launchQueries();
    fileOut();
    return 0;
}
