/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
int n;

int modPow(int a, int b, int mod){
    if(b==0) return 1;
    if(b%2==0){
        int c=modPow(a, b/2, mod);
        return (c*c)%mod;
    } else {
        return ( a * modPow(a, b-1, mod) )%mod;
    }
}

int calcDegree(int a, int b){
    int ans=0;
    while(b){
        ans+=b/a;
        b/=a;
    }
    return ans;
}

int calcMod8(int a){
    if(a==0) return 1;
    int ans=calcMod8(a/2);
    for(int i=1; i<=a%8; i++)
        if(i%2!=0) ans=(ans*i)%8;
    return ans;
}

int calcMod125(int a){
    if(a==0) return 1;
    int ans=calcMod125(a/5);
    for(int i=1; i<=a%125; i++)
        if(i%5!=0) ans=(ans*i)%125;
    if( ((a/125)%2)==1) ans=(ans*124)%125;
    return ans;
}

void readData(){
    freopen("factrl.in", "r", stdin);

    scanf("%d", &n);

    fclose(stdin);
}

void fileOut(){
    freopen("factrl.out", "w", stdout);

    int n2=calcDegree(2, n);
    int n5=calcDegree(5, n);

    int m8=(calcMod8(n)*modPow(5, n5, 8))%8;
    int m125=(calcMod125(n)*modPow(63, n2, 125))%125;

    int m1000=0;
    while(m1000%8!=m8 || m1000%125!=m125) m1000++;

    int ans=(m1000*modPow(2, n2-n5, 1000))%1000;

    printf("%03d\n", ans);

    fclose(stdout);
}

int main(){
    readData();
    fileOut();
    return 0;
}
