#include<fstream>
#include<cstdio>
#include<algorithm>
#define skill first
#define age second

using namespace std;

typedef pair<int, int> man;

int n, events[200000], order[200000], pos[200000], min_man[200000];
man arr[200000];

bool cmp(int i, int j){
    return arr[i] < arr[j];
}

int tree[800000];
void change(int pos, int num, int q, int l, int r){
    if(l+1 == r){
        tree[q] = num;
        return;
    }
    int m = (l+r)/2;
    if(pos < m)
        change(pos, num, q*2+1, l, m);
    else
        change(pos, num, q*2+2, m, r);
    tree[q] = max(tree[q*2+1], tree[q*2+2]);
}

int left_check(int age, int q, int l, int r){
    if(tree[q] <= age)
        return -1;
    if(l+1 == r)
        return l;
    int m = (l+r)/2;
    if(tree[q*2+1] > age)
        return left_check(age, q*2+1, l, m);
    return left_check(age, q*2+2, m, r);
}

int query(int pos, int age, int q, int l, int r){
    if(l+1 == r)
        return -1;
    int m = (l+r)/2;
    if(pos <= m){
        int left = query(pos, age, q*2+1, l, m);
        if(left != -1) return left;
        return left_check(age, q*2+2, m, r);
    }
    return query(pos, age, q*2+2, m, r);
}

int main(){
    ifstream in;
    in.open("cclub.in");
    ofstream out;
    out.open("cclub.out");
    in >> n;
    int mans = 0;
    for(int i = 0; i < n; ++i){
        char c;
        in >> c;
        if(c == 'P'){
            in >> arr[mans].age >> arr[mans].skill;
            events[i] = mans++;
        }
        else{
            int player;
            in >> player;
            events[i] = -player;
        }
    }
    for(int i = 0; i < mans; ++i)
        order[i] = i;
    sort(order, order + mans, cmp);
    for(int i = 0; i < mans; ++i)
        pos[order[i]] = i;
    min_man[mans-1] = mans-1;
    for(int i = mans-2; i >= 0; --i){
        if(arr[pos[i]].skill == arr[pos[i+1]].skill) min_man[i] = min_man[i+1];
        else min_man[i] = i;
    }
    for(int i = 0; i < n; ++i){
        if(events[i] >= 0){
            int player = events[i];
            change(pos[player], arr[player].age, 0, 0, mans + 1);
        }
        else{
            int player = -events[i]-1;
            if(min_man[pos[player]] == mans-1){
                out << 0 << endl;
                continue;
            }
            int ans = query(min_man[pos[player]]+1, arr[player].age, 0, 0, mans + 1);
            if(ans == -1)
                out << 0 << endl;
            else{
                out << order[ans]+1 << endl;
            }
        }
    }
    out.close();
    in.close();
}
