#include<iostream>
#include<cstdio>

using namespace std;

int pow(int a, int b, int mod){
    int ans = 1;
    int power = a;
    while(b){
        if(b & 1)
            ans = ans * power % mod;
        b >>= 1;
        power = power * power % mod;
    }
    return ans;
}

int mod8(int num){
    if(num == 0)
        return 1;
    int ans = mod8(num/2);
    for(int i = 1; i <= 8; ++i){
        if(i%2 == 0) continue;
        ans = ans * pow(i, num / 4, 8) % 8;
    }
    int i = 0;
    int prod = 0;
    while(i < num % 4){
        ++prod;
        if(prod % 2 == 0) continue;
        ans = ans * prod % 8;
        ++i;
    }
    return ans;
}

int mod125(int num){
    if(num == 0)
        return 1;
    int ans = mod125(num/5);
    for(int i = 1; i <= 125; ++i){
        if(i%5 == 0) continue;
        ans = ans * pow(i, num / 100, 125) % 125;
    }
    int i = 0;
    int prod = 0;
    while(i < num % 100){
        ++prod;
        if(prod % 5 == 0) continue;
        ans = ans * prod % 125;
        ++i;
    }
    return ans;
}

int num_of_two(int num){
    int sum = 0;
    while(num / 2)
        sum += (num /= 2);
    return sum;
}

int num_of_five(int num){
    int sum = 0;
    while(num / 5)
        sum += (num /= 5);
    return sum;
}

int main(){
    int n = 17;
    int n2 = num_of_two(n);
    int n5 = num_of_five(n);
    int m8 = mod8(n);
    int m125 = mod125(n);

    int power2 = pow(2, n2, 125);
    int N_0_mod_125;
    for(int i = 0; i < 125; ++i)
        if(power2 * i % 125 == m125){
            N_0_mod_125 = i;
            break;
        }

    int power5 = pow(5, n5, 8);
    int N_0_mod_8;
    for(int i = 0; i < 8; ++i)
        if(power5 * i % 8 == m8){
            N_0_mod_8 = i;
            break;
        }
    int N_0 = 0;
    while(N_0 % 8 != N_0_mod_8 || N_0 % 125 != N_0_mod_125)
        ++N_0;
    printf("%03d\n", 1ll * N_0 * pow(2, n2 - n5, 1000) % 1000);
}
