#include <iostream>
#include <cstdio>

using namespace std;

int b2[8], b5[125];

int bin_pow(int a, int b, int p) {
    int ans = 1;
    while(b) {
        if(b & 1)
            ans = ans*a % p;
        a = a*a % p;
        b >>= 1;
    }
    return ans;
}

int find2(int n) {
    if(n < 2)
        return b2[n];
    int ans;
    ans = find2(n / 2);
    ans *= bin_pow(b2[7], n/8, 8);
    ans %= 8;
    ans = ans * b2[n % 8];
    ans %= 8;
    return ans;
}

int find5(int n) {
    if(n < 5)
        return b5[n];
    int ans;
    ans = find5(n / 5);
    ans *= bin_pow(b5[124], n/125, 125);
    ans %= 125;
    ans = ans * b5[n % 125];
    ans %= 125;
    return ans;
}

int pow(int n, int p) {
    int ans = 0;
    int a = p;
    while(a <= n) {
        ans += n/a;
        a = a*p;
    }
    return ans;
}
int main()
{
    freopen("factrl.in", "r", stdin);
    freopen("factrl.out", "w", stdout);

    int n;
    scanf("%d", &n);
    b2[0] = 1;
    for(int i = 1;i < 8;++i)
        if(i % 2 != 0)
        b2[i] = (b2[i-1]*i) % 8;
        else
        b2[i] = b2[i-1];

    b5[0] = 1;
    for(int i = 1;i < 125;++i)
        if(i % 5 != 0)
        b5[i] = (b5[i-1]*i) % 125;
        else
        b5[i] = b5[i-1];

    int x = bin_pow(5, pow(n, 5), 8);
    int a = find2(n);

    int a0 = 0;
    while((a - a0 * x) % 8 != 0) a0++;
    int y = bin_pow(2, pow(n, 2), 125);
    int b = find5(n);

    int b0 = 0;
    while((b - b0 * y) % 125 != 0) b0++;

    int ans = 0;
    for(int i = 0;i < 1000;++i) {
        if(i % 8 == a0 && i % 125 == b0) {
            if(n > 6)
                printf("%03d\n", (bin_pow(2, pow(n, 2)-pow(n, 5), 1000)*i % 1000));
            else
                printf("%d\n", (bin_pow(2, pow(n, 2)-pow(n, 5), 1000)*i % 1000));
            return 0;
        }
    }
    return 0;
}
