/* GCC */
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>

using namespace std;

typedef pair<long long,long long> pll;


vector <long> request;
vector <pll> player;
vector <pll> tree;
vector <long> a;
vector <long> pos;
long n;

bool operator<(pll a,pll b){
    return a.first<b.first&&a.second<b.second;
}

bool cmp(long a,long b){
    return (player[a].first<player[b].first)||(player[a].second<player[b].second&&player[a].first==player[b].first);
}

void update(long v,long L,long R,long p,pll value){
    if (L==R) {
            tree[v] = value;
            return;
    }
    long m = (L+R)/2;
    if (p <= m) update(v*2,L,m,p,value);
    else update(v*2+1,m+1,R,p,value);
    if (tree[2*v].second > tree[2*v+1].second) tree[v] = tree[2*v];
    else tree[v] = tree[2*v+1];
}

long find_partner(long v,long L,long R,long num)
{
    if (tree[v].second<=player[a[num]].second) return -1;
    if (L==R){if (tree[v].first > player[a[num]].first) return L;return -1;}
    long m = (L + R)/2;
    long ans=-1;
    if (tree[2*v].second > player[a[num]].second) ans=find_partner(2*v,L,m,num);
    if (ans==-1) ans=find_partner(2*v+1,m+1,R,num);
    return ans;
}

int main()
{
    freopen("cclub.in","r",stdin);
    freopen("cclub.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    request.resize(n);
    player.push_back(pll(0,0));
    for (long i = 0;i < n;i++){
        string type;
        cin >> type;
        if (type == "P"){
            long a,b;
            cin >> a >> b;
            player.push_back(pll(a,b));
            request[i] = player.size()-1;
        }
        else {
            long num;
            cin >> num;
            request[i] = -num;
        }
    }
    tree.resize(4*n + 5,pll(0,0));
    a.resize(player.size());
    for (long i = 0;i < player.size();i++)
        a[i] = i;
    sort(a.begin(),a.end(),cmp);
    pos.resize(a.size());
    for (long i = 1;i < a.size();i++)
        pos[i] = a[i];
    for (long i = 0;i < n;i++)
    {
        if(request[i] > 0) update(1,1,player.size(),pos[request[i]],player[request[i]]);
        else {
            long partner;
            partner = find_partner(1,1,player.size(),pos[-request[i]]);
            if (partner == -1) cout << 0 << '\n';
            else cout << pos[partner] << '\n';
        }
    }
    return 0;
}
