#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <cstdio>

#define Nmax 200100
#define X first
#define Y second
using namespace std;

typedef vector<int> VI;
typedef long long ll;

int t[4 * Nmax] = {};

vector<pair<long long, long long> > players;

bool cmp(int l, int r) {
    return ((players[l].Y < players[r].Y) ||

    (players[l].Y == players[r].Y && players[l].X < players[r].X));
}

void update(int v, int l, int r, int pos, int x) {
    if(l > r) return;

    if(l == pos && r == pos) {
        t[v] = x;
        return;
    }


    int m = (l + r) / 2;
    if(pos <= m) update(2 * v, l, m, pos, x);
    else update(2 * v + 1, m + 1, r, pos, x);

    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int get_max(int v, int l, int r, int z) {
    if(t[v] <= z) return -1;

    if(l == r) return l;

    int m = (l + r) / 2;

    if(t[2 * v] > z) return get_max(2 * v, l, m, z);
    else return get_max(2 * v + 1, m + 1, r, z);
}

int get_ans(int v, int l, int r, int k, int z) {
    if(k > r || k < l || l >= r) return -1;

    int m = (l + r) / 2;

    if(m < k) return get_ans(2 * v + 1, m + 1, r, k, z);

    int left = get_ans(2 * v, l, m, k, z);
    if(left != -1) return left;
    return get_max(2 * v + 1, m + 1, r, z);
}

int main () {
	ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("cclub.in", "r", stdin);
    freopen("cclub.out", "w", stdout);

    int n;
    cin >> n;

    VI qw;
    int p = 0;
    for(int i = 0; i < n; i++) {
        char type;
        cin >> type;

        if(type == 'P') {
            ll age, lev;
            cin >> age >> lev;
            players.push_back(make_pair(age, lev));
            qw.push_back(p++);
        } else {
            int id;
            cin >> id;
            qw.push_back(-id);
        }
    }



    int len = players.size();
    VI x(len), sh(len), ord(len);

    for(int i = 0; i < len; i++)
        x[i] = i;

    sort(x.begin(), x.end(), cmp);

    for(int i = 0; i < len; i++) {
        ord[x[i]] = i;
    }

    sh[len - 1] = len - 1;
    for(int i = len - 2; i >= 0; i--)
        if(players[x[i]].Y == players[x[i + 1]].Y)
            sh[i] = sh[i + 1];
        else sh[i] = i;

    for(int i = 0; i < qw.size(); i++) {
            //cout << qw[i] << endl;
        int q = qw[i];
        if(q < 0) {
            int id = sh[ord[-q-1]];
            int ans = get_ans(1, 0, Nmax, id, players[-q-1].X);

            if(ans == -1) cout << "0\n";
            else cout << x[ans] + 1 << '\n';
        }
         else {
            int id = ord[q];

            update(1, 0, Nmax, id, players[q].X);
         }

    }
}
