#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <cstdio>

using namespace std;

long long calcdeg(long long n, long long p) {
    long long res = 0;

    while(n >= p) {
        n /= p;
        res += n;
    }
    return res;
}

long long modpow(long long a, long long b, long long m) {
    if(!b) return 1;
    long long r = modpow(a, b / 2, m);

    if(b & 1) r = (r * r * a) % m;
    else r = (r * r) % m;

    return r;
}

long long mod8(long long n) {
    if(!n) return 1;
    long long r = mod8(n / 2);

    for(long long i = 1; i <= n % 8; i++)
        if(i % 2 != 0) r = (r * i) % 8;

    return r;
}

long long mod125(long long n) {
    if(!n) return 1;
    long long r = mod125(n / 5);

    if((n/125) % 2 == 1) r = (r * 124) % 125;

    for(long long i = 1; i <= n % 125; i++)
        if(i % 5 != 0) r = (r * i) % 125;

    return r;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("factrl.in", "r", stdin);
    freopen("factrl.out", "w", stdout);
    long long n, m2, m5, m8, m125, m1000 = 0;

    cin >> n;

    m2 = calcdeg(n, 2);
    m5 = calcdeg(n, 5);
    m8 = mod8(n);
    m125 = mod125(n);

    //cout << m2 << ' ' << m5 << ' ' << m8 << ' ' << m125 << endl;

    m8 = (m8 * modpow(5, m5, 8)) % 8;
    m125 = (m125 * modpow(63, m2, 125)) % 125;

    while((m1000 % 8 != m8) || (m1000 % 125 != m125)) {
        m1000++;
    }

    long long ans = (m1000 * modpow(2, m2 - m5, 1000)) % 1000;
    if(ans < 100) cout << 0;
    if(ans < 10)  cout << 0;
    cout << ans << endl;
}
